import '_model.dart';

class HomeDetailInfo {
  num? id;
  String? uuid;
  num? numberOfRooms;
  num? numberOfBeds;
  num? numberOfBedRooms;
  num? numberOfBathRooms;
  String? currency;
  String? title;
  String? slug;
  String? shortDescription;
  String? priceRentFormat;
  num? priceRent;
  String? priceSaleFormat;
  num? priceSale;
  String? priceBouquetViagerFormat;
  num? priceBouquetViager;
  String? priceRentViagerFormat;
  num? priceRentViager;
  String? priceShortRentByHourFormat;
  num? priceShortRentByHour;
  String? priceShortRentByDayFormat;
  num? priceShortRentByDay;
  String? priceShortRentByWeekFormat;
  num? priceShortRentByWeek;
  String? priceShortRentByMonthFormat;
  num? priceShortRentByMonth;
  num? minHoursContractForShortRent;
  num? minYearsContractForLongTermRent;
  String? sizeUnit;
  num? area;
  num? buildingNumberOfFloors;
  num? maxGuests;
  num? ratings;
  num? openForBid;
  num? minBidPrice;
  String? minBidPriceFormat;
  num? lat;
  num? lng;
  String? district;
  String? city;
  String? country;
  String? countryCode;
  String? county;
  String? state;
  String? street;
  String? zip;
  num? isFeatured;
  num? isFeaturedUntil;
  num? isHomelidoSelection;
  num? createdAt;
  num? updatedAt;
  HomePurposeType? purposeType;
  HomeDetailContact? user;
  HomeDetailContact? pro;
  HomeCategory? maincat;
  HomeSubcat? subcat;
  HomeDetailPictureUrl? mainPictureUrl;
  List<HomeDetailPictureUrl>? galleryPictureUrl;
  HomeDetailPeb? peb;
  List<HomeDetailAttributes>? attributes;
  HomeDetailContacts? contacts;
  HomeDetailAgency? agency;
  String? longDescription;
  String? videoUrl;
  String? youtubeVideoUrl;
  String? referenceAgency;
  String? referenceHomelido;
  String? adLanguageCode;
  bool? isFurnished;
  num? gardenArea;
  num? terrasseArea;
  num? landArea;
  num? balconyArea;
  num? floorPosition;
  num? numberOfnumeriorParking;
  num? numberOfExteriorParking;
  num? numberOfToilets;
  num? bedroom1Area;
  num? bedroom2Area;
  num? bedroom3Area;
  num? bedroom4Area;
  num? bedroom5Area;
  num? bedroom6Area;
  num? livingroomArea;
  num? diningroomArea;
  num? office1Area;
  num? office2Area;
  num? office3Area;
  num? office4Area;
  num? office5Area;
  num? office6Area;
  num? numberOfOffices;
  num? kitchenArea;
  num? heatingType;
  num? co2Emission;
  num? energyLevel;
  num? cadastralIncome;
  String? pebUniqueCode;
  num? pebValidUntil;
  num? pebDate;
  String? lastTimeViewed;
  num? isInstantBooking;
  num? allowChildren;
  num? yearBuilt;
  num? yearRemodal;
  num? numberOfGarages;
  num? deposit;
  String? poolSize;
  num? enableExtraFees;
  num? homeType;
  String? lastView;
  num? timeSlide;
  String? qrCode;
  num? numberofReminders;
  num? numberOfPrivateParkingPlaces;
  num? estimateMonthlyIndivCharges;
  num? numberOfFloorOfBuilding;
  num? accessibility;
  num? underOption;
  num? fixedCharges;
  num? landSize;
  num? bedroom1NumberOfBeds;
  num? bedroom2NumberOfBeds;
  num? bedroom3NumberOfBeds;
  num? bedroom4NumberOfBeds;
  num? bedroom5NumberOfBeds;
  num? bedroom6NumberOfBeds;
  String? formattedAddress;
  int? isFavorited;

  HomeDetailInfo({
    this.agency,
    this.id,
    this.uuid,
    this.numberOfRooms,
    this.numberOfBeds,
    this.numberOfBedRooms,
    this.numberOfBathRooms,
    this.currency,
    this.title,
    this.slug,
    this.shortDescription,
    this.priceRentFormat,
    this.priceSaleFormat,
    this.priceBouquetViagerFormat,
    this.priceRentViagerFormat,
    this.priceShortRentByHourFormat,
    this.priceShortRentByDayFormat,
    this.priceShortRentByWeekFormat,
    this.priceShortRentByMonthFormat,
    this.minHoursContractForShortRent,
    this.minYearsContractForLongTermRent,
    this.sizeUnit,
    this.area,
    this.buildingNumberOfFloors,
    this.maxGuests,
    this.ratings,
    this.openForBid,
    this.minBidPrice,
    this.minBidPriceFormat,
    this.lat,
    this.lng,
    this.district,
    this.city,
    this.country,
    this.countryCode,
    this.county,
    this.state,
    this.street,
    this.zip,
    this.isFeatured,
    this.isFeaturedUntil,
    this.isHomelidoSelection,
    this.createdAt,
    this.updatedAt,
    this.purposeType,
    this.user,
    this.pro,
    this.maincat,
    this.subcat,
    this.mainPictureUrl,
    this.galleryPictureUrl,
    this.peb,
    this.attributes,
    this.contacts,
    this.longDescription,
    this.videoUrl,
    this.youtubeVideoUrl,
    this.referenceAgency,
    this.referenceHomelido,
    this.adLanguageCode,
    this.isFurnished,
    this.gardenArea,
    this.terrasseArea,
    this.landArea,
    this.balconyArea,
    this.floorPosition,
    this.numberOfnumeriorParking,
    this.numberOfExteriorParking,
    this.numberOfToilets,
    this.bedroom1Area,
    this.bedroom2Area,
    this.bedroom3Area,
    this.bedroom4Area,
    this.bedroom5Area,
    this.bedroom6Area,
    this.livingroomArea,
    this.diningroomArea,
    this.office1Area,
    this.office2Area,
    this.office3Area,
    this.office4Area,
    this.office5Area,
    this.office6Area,
    this.numberOfOffices,
    this.kitchenArea,
    this.heatingType,
    this.co2Emission,
    this.energyLevel,
    this.cadastralIncome,
    this.pebUniqueCode,
    this.pebValidUntil,
    this.pebDate,
    this.lastTimeViewed,
    this.isInstantBooking,
    this.allowChildren,
    this.yearBuilt,
    this.yearRemodal,
    this.numberOfGarages,
    this.deposit,
    this.poolSize,
    this.enableExtraFees,
    this.homeType,
    this.lastView,
    this.timeSlide,
    this.qrCode,
    this.numberofReminders,
    this.numberOfPrivateParkingPlaces,
    this.estimateMonthlyIndivCharges,
    this.numberOfFloorOfBuilding,
    this.accessibility,
    this.underOption,
    this.fixedCharges,
    this.landSize,
    this.bedroom1NumberOfBeds,
    this.bedroom2NumberOfBeds,
    this.bedroom3NumberOfBeds,
    this.bedroom4NumberOfBeds,
    this.bedroom5NumberOfBeds,
    this.bedroom6NumberOfBeds,
    this.formattedAddress,
    this.isFavorited,
  });

  HomeDetailInfo.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    isFavorited = json["isFavorited"];
    formattedAddress = json["formattedAddress"];
    uuid = json["uuid"];
    numberOfRooms = json["numberOfRooms"];
    numberOfBeds = json["numberOfBeds"];
    numberOfBedRooms = json["numberOfBedRooms"];
    numberOfBathRooms = json["numberOfBathRooms"];
    currency = json["currency"];
    title = json["title"];
    slug = json["slug"];
    shortDescription = json["shortDescription"];
    priceRentFormat = json["priceRentFormat"];
    priceRent = json["priceRent"];
    priceSaleFormat = json["priceSaleFormat"];
    priceSale = json["priceSale"];
    priceBouquetViagerFormat = json["priceBouquetViagerFormat"];
    priceBouquetViager = json["priceBouquetViager"];
    priceRentViagerFormat = json["priceRentViagerFormat"];
    priceRentViager = json["priceRentViager"];
    priceShortRentByHourFormat = json["priceShortRentByHourFormat"];
    priceShortRentByHour = json["priceShortRentByHour"];
    priceShortRentByDayFormat = json["priceShortRentByDayFormat"];
    priceShortRentByDay = json["priceShortRentByDay"];
    priceShortRentByWeekFormat = json["priceShortRentByWeekFormat"];
    priceShortRentByWeek = json["priceShortRentByWeek"];
    priceShortRentByMonthFormat = json["priceShortRentByMonthFormat"];
    priceShortRentByMonth = json["priceShortRentByMonth"];
    minHoursContractForShortRent = json["minHoursContractForShortRent"];
    minYearsContractForLongTermRent = json["minYearsContractForLongTermRent"];
    sizeUnit = json["sizeUnit"];
    area = json["area"];
    buildingNumberOfFloors = json["buildingNumberOfFloors"];
    maxGuests = json["maxGuests"];
    ratings = json["ratings"];
    openForBid = json["openForBid"];
    minBidPrice = json["minBidPrice"];
    minBidPriceFormat = json["minBidPriceFormat"];
    lat = json["lat"];
    lng = json["lng"];
    district = json["district"];
    city = json["city"];
    country = json["country"];
    countryCode = json["countryCode"];
    county = json["county"];
    state = json["state"];
    street = json["street"];
    zip = json["zip"];
    isFeatured = json["isFeatured"];
    isFeaturedUntil = json["isFeaturedUntil"];
    isHomelidoSelection = json["isHomelidoSelection"];
    createdAt = json["createdAt"];
    updatedAt = json["updatedAt"];
    purposeType = json["purposeType"] == null
        ? null
        : HomePurposeType.fromJson(json["purposeType"]);
    user =
        json["user"] == null ? null : HomeDetailContact.fromJson(json["user"]);
    pro = json["pro"] == null ? null : HomeDetailContact.fromJson(json["pro"]);
    maincat =
        json["maincat"] == null ? null : HomeCategory.fromJson(json["maincat"]);
    subcat =
        json["subcat"] == null ? null : HomeSubcat.fromJson(json["subcat"]);
    mainPictureUrl = json["mainPictureUrl"] == null
        ? null
        : HomeDetailPictureUrl.fromJson(json["mainPictureUrl"]);
    galleryPictureUrl = json["galleryPictureUrl"] == null
        ? null
        : (json["galleryPictureUrl"] as List)
            .map((e) => HomeDetailPictureUrl.fromJson(e))
            .toList();
    peb = json["peb"] == null ? null : HomeDetailPeb.fromJson(json["peb"]);
    attributes = json["attributes"] == null
        ? null
        : (json["attributes"] as List)
            .map((e) => HomeDetailAttributes.fromJson(e))
            .toList();
    contacts = json["contacts"] == null
        ? null
        : HomeDetailContacts.fromJson(json["contacts"]);
    agency = json["agency"] == null
        ? null
        : HomeDetailAgency.fromJson(json["agency"]);
    longDescription = json["longDescription"];
    videoUrl = json["videoUrl"];
    youtubeVideoUrl = json["youtubeVideoUrl"];
    referenceAgency = json["referenceAgency"];
    referenceHomelido = json["referenceHomelido"];
    adLanguageCode = json["adLanguageCode"];
    isFurnished = json["isFurnished"];
    gardenArea = json["gardenArea"];
    terrasseArea = json["terrasseArea"];
    landArea = json["landArea"];
    balconyArea = json["balconyArea"];
    floorPosition = json["floorPosition"];
    numberOfnumeriorParking = json["numberOfnumeriorParking"];
    numberOfExteriorParking = json["numberOfExteriorParking"];
    numberOfToilets = json["numberOfToilets"];
    bedroom1Area = json["bedroom1Area"];
    bedroom2Area = json["bedroom2Area"];
    bedroom3Area = json["bedroom3Area"];
    bedroom4Area = json["bedroom4Area"];
    bedroom5Area = json["bedroom5Area"];
    bedroom6Area = json["bedroom6Area"];
    livingroomArea = json["livingroomArea"];
    diningroomArea = json["diningroomArea"];
    office1Area = json["office1Area"];
    office2Area = json["office2Area"];
    office3Area = json["office3Area"];
    office4Area = json["office4Area"];
    office5Area = json["office5Area"];
    office6Area = json["office6Area"];
    numberOfOffices = json["numberOfOffices"];
    kitchenArea = json["kitchenArea"];
    heatingType = json["heatingType"];
    co2Emission = json["co2Emission"];
    energyLevel = json["energyLevel"];
    cadastralIncome = json["cadastralIncome"];
    pebUniqueCode = json["pebUniqueCode"];
    pebValidUntil = json["pebValidUntil"];
    pebDate = json["pebDate"];
    lastTimeViewed = json["lastTimeViewed"];
    isInstantBooking = json["isInstantBooking"];
    allowChildren = json["allowChildren"];
    yearBuilt = json["yearBuilt"];
    yearRemodal = json["yearRemodal"];
    numberOfGarages = json["numberOfGarages"];
    deposit = json["deposit"];
    poolSize = json["poolSize"];
    enableExtraFees = json["enableExtraFees"];
    homeType = json["homeType"];
    lastView = json["lastView"];
    timeSlide = json["timeSlide"];
    qrCode = json["qrCode"];
    numberofReminders = json["numberofReminders"];
    numberOfPrivateParkingPlaces = json["numberOfPrivateParkingPlaces"];
    estimateMonthlyIndivCharges = json["estimateMonthlyIndivCharges"];
    numberOfFloorOfBuilding = json["numberOfFloorOfBuilding"];
    accessibility = json["accessibility"];
    underOption = json["underOption"];
    fixedCharges = json["fixedCharges"];
    landSize = json["landSize"];
    bedroom1NumberOfBeds = json["bedroom1NumberOfBeds"];
    bedroom2NumberOfBeds = json["bedroom2NumberOfBeds"];
    bedroom3NumberOfBeds = json["bedroom3NumberOfBeds"];
    bedroom4NumberOfBeds = json["bedroom4NumberOfBeds"];
    bedroom5NumberOfBeds = json["bedroom5NumberOfBeds"];
    bedroom6NumberOfBeds = json["bedroom6NumberOfBeds"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["uuid"] = uuid;
    _data["numberOfRooms"] = numberOfRooms;
    _data["numberOfBeds"] = numberOfBeds;
    _data["numberOfBedRooms"] = numberOfBedRooms;
    _data["numberOfBathRooms"] = numberOfBathRooms;
    _data["currency"] = currency;
    _data["title"] = title;
    _data["slug"] = slug;
    _data["shortDescription"] = shortDescription;
    _data["priceRentFormat"] = priceRentFormat;
    _data["priceSaleFormat"] = priceSaleFormat;
    _data["priceBouquetViagerFormat"] = priceBouquetViagerFormat;
    _data["priceRentViagerFormat"] = priceRentViagerFormat;
    _data["priceShortRentByHourFormat"] = priceShortRentByHourFormat;
    _data["priceShortRentByDayFormat"] = priceShortRentByDayFormat;
    _data["priceShortRentByWeekFormat"] = priceShortRentByWeekFormat;
    _data["priceShortRentByMonthFormat"] = priceShortRentByMonthFormat;
    _data["minHoursContractForShortRent"] = minHoursContractForShortRent;
    _data["sizeUnit"] = sizeUnit;
    _data["area"] = area;
    _data["buildingNumberOfFloors"] = buildingNumberOfFloors;
    _data["maxGuests"] = maxGuests;
    _data["ratings"] = ratings;
    _data["openForBid"] = openForBid;
    _data["minBidPrice"] = minBidPrice;
    _data["minBidPriceFormat"] = minBidPriceFormat;
    _data["lat"] = lat;
    _data["lng"] = lng;
    _data["district"] = district;
    _data["city"] = city;
    _data["country"] = country;
    _data["countryCode"] = countryCode;
    _data["county"] = county;
    _data["state"] = state;
    _data["street"] = street;
    _data["zip"] = zip;
    _data["isFeatured"] = isFeatured;
    _data["isFeaturedUntil"] = isFeaturedUntil;
    _data["isHomelidoSelection"] = isHomelidoSelection;
    _data["createdAt"] = createdAt;
    _data["updatedAt"] = updatedAt;
    if (purposeType != null) {
      _data["purposeType"] = purposeType?.toJson();
    }
    if (user != null) {
      _data["user"] = user?.toJson();
    }
    if (pro != null) {
      _data["pro"] = pro?.toJson();
    }
    if (maincat != null) {
      _data["maincat"] = maincat?.toJson();
    }
    if (subcat != null) {
      _data["subcat"] = subcat?.toJson();
    }
    if (mainPictureUrl != null) {
      _data["mainPictureUrl"] = mainPictureUrl?.toJson();
    }
    if (galleryPictureUrl != null) {
      _data["galleryPictureUrl"] =
          galleryPictureUrl?.map((e) => e.toJson()).toList();
    }
    if (peb != null) {
      _data["peb"] = peb?.toJson();
    }
    if (attributes != null) {
      _data["attributes"] = attributes?.map((e) => e.toJson()).toList();
    }
    _data["longDescription"] = longDescription;
    _data["videoUrl"] = videoUrl;
    _data["youtubeVideoUrl"] = youtubeVideoUrl;
    _data["referenceAgency"] = referenceAgency;
    _data["referenceHomelido"] = referenceHomelido;
    _data["adLanguageCode"] = adLanguageCode;
    _data["isFurnished"] = isFurnished;
    _data["gardenArea"] = gardenArea;
    _data["terrasseArea"] = terrasseArea;
    _data["landArea"] = landArea;
    _data["balconyArea"] = balconyArea;
    _data["floorPosition"] = floorPosition;
    _data["numberOfnumeriorParking"] = numberOfnumeriorParking;
    _data["numberOfExteriorParking"] = numberOfExteriorParking;
    _data["numberOfToilets"] = numberOfToilets;
    _data["bedroom1Area"] = bedroom1Area;
    _data["bedroom2Area"] = bedroom2Area;
    _data["bedroom3Area"] = bedroom3Area;
    _data["bedroom4Area"] = bedroom4Area;
    _data["bedroom5Area"] = bedroom5Area;
    _data["bedroom6Area"] = bedroom6Area;
    _data["livingroomArea"] = livingroomArea;
    _data["diningroomArea"] = diningroomArea;
    _data["office1Area"] = office1Area;
    _data["office2Area"] = office2Area;
    _data["office3Area"] = office3Area;
    _data["office4Area"] = office4Area;
    _data["office5Area"] = office5Area;
    _data["office6Area"] = office6Area;
    _data["numberOfOffices"] = numberOfOffices;
    _data["kitchenArea"] = kitchenArea;
    _data["heatingType"] = heatingType;
    _data["co2Emission"] = co2Emission;
    _data["energyLevel"] = energyLevel;
    _data["cadastralIncome"] = cadastralIncome;
    _data["pebUniqueCode"] = pebUniqueCode;
    _data["pebValidUntil"] = pebValidUntil;
    _data["pebDate"] = pebDate;
    _data["lastTimeViewed"] = lastTimeViewed;
    _data["isInstantBooking"] = isInstantBooking;
    _data["allowChildren"] = allowChildren;
    _data["yearBuilt"] = yearBuilt;
    _data["yearRemodal"] = yearRemodal;
    _data["numberOfGarages"] = numberOfGarages;
    _data["deposit"] = deposit;
    _data["poolSize"] = poolSize;
    _data["enableExtraFees"] = enableExtraFees;
    _data["homeType"] = homeType;
    _data["lastView"] = lastView;
    _data["timeSlide"] = timeSlide;
    _data["qrCode"] = qrCode;
    _data["numberofReminders"] = numberofReminders;
    _data["numberOfPrivateParkingPlaces"] = numberOfPrivateParkingPlaces;
    _data["estimateMonthlyIndivCharges"] = estimateMonthlyIndivCharges;
    _data["numberOfFloorOfBuilding"] = numberOfFloorOfBuilding;
    _data["accessibility"] = accessibility;
    _data["underOption"] = underOption;
    _data["fixedCharges"] = fixedCharges;
    _data["landSize"] = landSize;
    _data["bedroom1NumberOfBeds"] = bedroom1NumberOfBeds;
    _data["bedroom2NumberOfBeds"] = bedroom2NumberOfBeds;
    _data["bedroom3NumberOfBeds"] = bedroom3NumberOfBeds;
    _data["bedroom4NumberOfBeds"] = bedroom4NumberOfBeds;
    _data["bedroom5NumberOfBeds"] = bedroom5NumberOfBeds;
    _data["bedroom6NumberOfBeds"] = bedroom6NumberOfBeds;
    return _data;
  }

  HomeDetailInfo copyWith({
    num? id,
    String? uuid,
    num? numberOfRooms,
    num? numberOfBeds,
    num? numberOfBedRooms,
    num? numberOfBathRooms,
    String? currency,
    String? title,
    String? slug,
    String? shortDescription,
    String? priceRentFormat,
    String? priceSaleFormat,
    String? priceBouquetViagerFormat,
    String? priceRentViagerFormat,
    String? priceShortRentByHourFormat,
    String? priceShortRentByDayFormat,
    String? priceShortRentByWeekFormat,
    String? priceShortRentByMonthFormat,
    num? minHoursContractForShortRent,
    String? sizeUnit,
    num? area,
    num? buildingNumberOfFloors,
    num? maxGuests,
    num? ratings,
    num? openForBid,
    num? minBidPrice,
    String? minBidPriceFormat,
    num? lat,
    num? lng,
    String? district,
    String? city,
    String? country,
    String? countryCode,
    String? county,
    String? state,
    String? street,
    String? zip,
    num? isFeatured,
    num? isFeaturedUntil,
    num? isHomelidoSelection,
    num? createdAt,
    num? updatedAt,
    HomePurposeType? purposeType,
    HomeDetailContact? user,
    HomeDetailContact? pro,
    HomeCategory? maincat,
    HomeSubcat? subcat,
    HomeDetailPictureUrl? mainPictureUrl,
    List<HomeDetailPictureUrl>? galleryPictureUrl,
    HomeDetailPeb? peb,
    List<HomeDetailAttributes>? attributes,
    HomeDetailContacts? contacts,
    String? longDescription,
    String? videoUrl,
    String? youtubeVideoUrl,
    String? referenceAgency,
    String? referenceHomelido,
    String? adLanguageCode,
    bool? isFurnished,
    num? gardenArea,
    num? terrasseArea,
    num? landArea,
    num? balconyArea,
    num? floorPosition,
    num? numberOfnumeriorParking,
    num? numberOfExteriorParking,
    num? numberOfToilets,
    num? bedroom1Area,
    num? bedroom2Area,
    num? bedroom3Area,
    num? bedroom4Area,
    num? bedroom5Area,
    num? bedroom6Area,
    num? livingroomArea,
    num? diningroomArea,
    num? office1Area,
    num? office2Area,
    num? office3Area,
    num? office4Area,
    num? office5Area,
    num? office6Area,
    num? numberOfOffices,
    num? kitchenArea,
    num? heatingType,
    num? co2Emission,
    num? energyLevel,
    num? cadastralIncome,
    String? pebUniqueCode,
    num? pebValidUntil,
    num? pebDate,
    String? lastTimeViewed,
    num? isInstantBooking,
    num? allowChildren,
    num? yearBuilt,
    num? yearRemodal,
    num? numberOfGarages,
    num? deposit,
    String? poolSize,
    num? enableExtraFees,
    num? homeType,
    String? lastView,
    num? timeSlide,
    String? qrCode,
    num? numberofReminders,
    num? numberOfPrivateParkingPlaces,
    num? estimateMonthlyIndivCharges,
    num? numberOfFloorOfBuilding,
    num? accessibility,
    num? underOption,
    num? fixedCharges,
    num? landSize,
    num? bedroom1NumberOfBeds,
    num? bedroom2NumberOfBeds,
    num? bedroom3NumberOfBeds,
    num? bedroom4NumberOfBeds,
    num? bedroom5NumberOfBeds,
    num? bedroom6NumberOfBeds,
  }) =>
      HomeDetailInfo(
        id: id ?? this.id,
        uuid: uuid ?? this.uuid,
        numberOfRooms: numberOfRooms ?? this.numberOfRooms,
        numberOfBeds: numberOfBeds ?? this.numberOfBeds,
        numberOfBedRooms: numberOfBedRooms ?? this.numberOfBedRooms,
        numberOfBathRooms: numberOfBathRooms ?? this.numberOfBathRooms,
        currency: currency ?? this.currency,
        title: title ?? this.title,
        slug: slug ?? this.slug,
        shortDescription: shortDescription ?? this.shortDescription,
        priceRentFormat: priceRentFormat ?? this.priceRentFormat,
        priceSaleFormat: priceSaleFormat ?? this.priceSaleFormat,
        priceBouquetViagerFormat:
            priceBouquetViagerFormat ?? this.priceBouquetViagerFormat,
        priceRentViagerFormat:
            priceRentViagerFormat ?? this.priceRentViagerFormat,
        priceShortRentByHourFormat:
            priceShortRentByHourFormat ?? this.priceShortRentByHourFormat,
        priceShortRentByDayFormat:
            priceShortRentByDayFormat ?? this.priceShortRentByDayFormat,
        priceShortRentByWeekFormat:
            priceShortRentByWeekFormat ?? this.priceShortRentByWeekFormat,
        priceShortRentByMonthFormat:
            priceShortRentByMonthFormat ?? this.priceShortRentByMonthFormat,
        minHoursContractForShortRent:
            minHoursContractForShortRent ?? this.minHoursContractForShortRent,
        sizeUnit: sizeUnit ?? this.sizeUnit,
        area: area ?? this.area,
        buildingNumberOfFloors:
            buildingNumberOfFloors ?? this.buildingNumberOfFloors,
        maxGuests: maxGuests ?? this.maxGuests,
        ratings: ratings ?? this.ratings,
        openForBid: openForBid ?? this.openForBid,
        minBidPrice: minBidPrice ?? this.minBidPrice,
        minBidPriceFormat: minBidPriceFormat ?? this.minBidPriceFormat,
        lat: lat ?? this.lat,
        lng: lng ?? this.lng,
        district: district ?? this.district,
        city: city ?? this.city,
        country: country ?? this.country,
        countryCode: countryCode ?? this.countryCode,
        county: county ?? this.county,
        state: state ?? this.state,
        street: street ?? this.street,
        zip: zip ?? this.zip,
        isFeatured: isFeatured ?? this.isFeatured,
        isFeaturedUntil: isFeaturedUntil ?? this.isFeaturedUntil,
        isHomelidoSelection: isHomelidoSelection ?? this.isHomelidoSelection,
        createdAt: createdAt ?? this.createdAt,
        updatedAt: updatedAt ?? this.updatedAt,
        purposeType: purposeType ?? this.purposeType,
        user: user ?? this.user,
        pro: pro ?? this.pro,
        maincat: maincat ?? this.maincat,
        subcat: subcat ?? this.subcat,
        mainPictureUrl: mainPictureUrl ?? this.mainPictureUrl,
        galleryPictureUrl: galleryPictureUrl ?? this.galleryPictureUrl,
        peb: peb ?? this.peb,
        attributes: attributes ?? this.attributes,
        contacts: contacts ?? this.contacts,
        longDescription: longDescription ?? this.longDescription,
        videoUrl: videoUrl ?? this.videoUrl,
        youtubeVideoUrl: youtubeVideoUrl ?? this.youtubeVideoUrl,
        referenceAgency: referenceAgency ?? this.referenceAgency,
        referenceHomelido: referenceHomelido ?? this.referenceHomelido,
        adLanguageCode: adLanguageCode ?? this.adLanguageCode,
        isFurnished: isFurnished ?? this.isFurnished,
        gardenArea: gardenArea ?? this.gardenArea,
        terrasseArea: terrasseArea ?? this.terrasseArea,
        landArea: landArea ?? this.landArea,
        balconyArea: balconyArea ?? this.balconyArea,
        floorPosition: floorPosition ?? this.floorPosition,
        numberOfnumeriorParking:
            numberOfnumeriorParking ?? this.numberOfnumeriorParking,
        numberOfExteriorParking:
            numberOfExteriorParking ?? this.numberOfExteriorParking,
        numberOfToilets: numberOfToilets ?? this.numberOfToilets,
        bedroom1Area: bedroom1Area ?? this.bedroom1Area,
        bedroom2Area: bedroom2Area ?? this.bedroom2Area,
        bedroom3Area: bedroom3Area ?? this.bedroom3Area,
        bedroom4Area: bedroom4Area ?? this.bedroom4Area,
        bedroom5Area: bedroom5Area ?? this.bedroom5Area,
        bedroom6Area: bedroom6Area ?? this.bedroom6Area,
        livingroomArea: livingroomArea ?? this.livingroomArea,
        diningroomArea: diningroomArea ?? this.diningroomArea,
        office1Area: office1Area ?? this.office1Area,
        office2Area: office2Area ?? this.office2Area,
        office3Area: office3Area ?? this.office3Area,
        office4Area: office4Area ?? this.office4Area,
        office5Area: office5Area ?? this.office5Area,
        office6Area: office6Area ?? this.office6Area,
        numberOfOffices: numberOfOffices ?? this.numberOfOffices,
        kitchenArea: kitchenArea ?? this.kitchenArea,
        heatingType: heatingType ?? this.heatingType,
        co2Emission: co2Emission ?? this.co2Emission,
        energyLevel: energyLevel ?? this.energyLevel,
        cadastralIncome: cadastralIncome ?? this.cadastralIncome,
        pebUniqueCode: pebUniqueCode ?? this.pebUniqueCode,
        pebValidUntil: pebValidUntil ?? this.pebValidUntil,
        pebDate: pebDate ?? this.pebDate,
        lastTimeViewed: lastTimeViewed ?? this.lastTimeViewed,
        isInstantBooking: isInstantBooking ?? this.isInstantBooking,
        allowChildren: allowChildren ?? this.allowChildren,
        yearBuilt: yearBuilt ?? this.yearBuilt,
        yearRemodal: yearRemodal ?? this.yearRemodal,
        numberOfGarages: numberOfGarages ?? this.numberOfGarages,
        deposit: deposit ?? this.deposit,
        poolSize: poolSize ?? this.poolSize,
        enableExtraFees: enableExtraFees ?? this.enableExtraFees,
        homeType: homeType ?? this.homeType,
        lastView: lastView ?? this.lastView,
        timeSlide: timeSlide ?? this.timeSlide,
        qrCode: qrCode ?? this.qrCode,
        numberofReminders: numberofReminders ?? this.numberofReminders,
        numberOfPrivateParkingPlaces:
            numberOfPrivateParkingPlaces ?? this.numberOfPrivateParkingPlaces,
        estimateMonthlyIndivCharges:
            estimateMonthlyIndivCharges ?? this.estimateMonthlyIndivCharges,
        numberOfFloorOfBuilding:
            numberOfFloorOfBuilding ?? this.numberOfFloorOfBuilding,
        accessibility: accessibility ?? this.accessibility,
        underOption: underOption ?? this.underOption,
        fixedCharges: fixedCharges ?? this.fixedCharges,
        landSize: landSize ?? this.landSize,
        bedroom1NumberOfBeds: bedroom1NumberOfBeds ?? this.bedroom1NumberOfBeds,
        bedroom2NumberOfBeds: bedroom2NumberOfBeds ?? this.bedroom2NumberOfBeds,
        bedroom3NumberOfBeds: bedroom3NumberOfBeds ?? this.bedroom3NumberOfBeds,
        bedroom4NumberOfBeds: bedroom4NumberOfBeds ?? this.bedroom4NumberOfBeds,
        bedroom5NumberOfBeds: bedroom5NumberOfBeds ?? this.bedroom5NumberOfBeds,
        bedroom6NumberOfBeds: bedroom6NumberOfBeds ?? this.bedroom6NumberOfBeds,
      );
}

class HomeDetailContacts {
  List<HomeDetailContact>? pros;
  List<HomeDetailContact>? users;

  HomeDetailContacts({this.pros, this.users});

  HomeDetailContacts.fromJson(Map<String, dynamic> json) {
    pros = json["pros"] == null
        ? null
        : (json["pros"] as List)
            .map((e) => HomeDetailContact.fromJson(e))
            .toList();
    users = json["users"] == null
        ? null
        : (json["users"] as List)
            .map((e) => HomeDetailContact.fromJson(e))
            .toList();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    if (pros != null) {
      _data["pros"] = pros?.map((e) => e.toJson()).toList();
    }
    if (users != null) {
      _data["users"] = users?.map((e) => e.toJson()).toList();
    }
    return _data;
  }

  HomeDetailContacts copyWith({
    List<HomeDetailContact>? pros,
    List<HomeDetailContact>? users,
  }) =>
      HomeDetailContacts(
        pros: pros ?? this.pros,
        users: users ?? this.users,
      );
}

class HomeDetailAttributes {
  num? id;
  String? name;
  String? description;
  String? thumbnailUrl;
  List<Collection>? collection;

  HomeDetailAttributes(
      {this.id,
      this.name,
      this.description,
      this.thumbnailUrl,
      this.collection});

  HomeDetailAttributes.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    name = json["name"];
    description = json["description"];
    thumbnailUrl = json["thumbnailUrl"];
    collection = json["collection"] == null
        ? null
        : (json["collection"] as List)
            .map((e) => Collection.fromJson(e))
            .toList();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["name"] = name;
    _data["description"] = description;
    _data["thumbnailUrl"] = thumbnailUrl;
    if (collection != null) {
      _data["collection"] = collection?.map((e) => e.toJson()).toList();
    }
    return _data;
  }

  HomeDetailAttributes copyWith({
    num? id,
    String? name,
    String? description,
    String? thumbnailUrl,
    List<Collection>? collection,
  }) =>
      HomeDetailAttributes(
        id: id ?? this.id,
        name: name ?? this.name,
        description: description ?? this.description,
        thumbnailUrl: thumbnailUrl ?? this.thumbnailUrl,
        collection: collection ?? this.collection,
      );
}

class Collection {
  num? id;
  String? label;

  Collection({this.id, this.label});

  Collection.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    label = json["label"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    return _data;
  }

  Collection copyWith({
    num? id,
    String? label,
  }) =>
      Collection(
        id: id ?? this.id,
        label: label ?? this.label,
      );
}

class HomeDetailPeb {
  num? id;
  dynamic label;
  dynamic colorCode;
  dynamic pictureUrl;

  HomeDetailPeb({this.id, this.label, this.colorCode, this.pictureUrl});

  HomeDetailPeb.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    label = json["label"];
    colorCode = json["colorCode"];
    pictureUrl = json["pictureUrl"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["label"] = label;
    _data["colorCode"] = colorCode;
    _data["pictureUrl"] = pictureUrl;
    return _data;
  }

  HomeDetailPeb copyWith({
    num? id,
    dynamic label,
    dynamic colorCode,
    dynamic pictureUrl,
  }) =>
      HomeDetailPeb(
        id: id ?? this.id,
        label: label ?? this.label,
        colorCode: colorCode ?? this.colorCode,
        pictureUrl: pictureUrl ?? this.pictureUrl,
      );
}

class HomeDetailPictureUrl {
  num? id;
  dynamic url;
  dynamic compressedUrl;
  dynamic label;
  dynamic whisePictureId;

  HomeDetailPictureUrl(
      {this.id, this.url, this.compressedUrl, this.label, this.whisePictureId});

  HomeDetailPictureUrl.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    url = json["url"];
    compressedUrl = json["compressedUrl"];
    label = json["label"];
    whisePictureId = json["whisePictureId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["url"] = url;
    _data["compressedUrl"] = compressedUrl;
    _data["label"] = label;
    _data["whisePictureId"] = whisePictureId;
    return _data;
  }

  HomeDetailPictureUrl copyWith({
    num? id,
    dynamic url,
    dynamic compressedUrl,
    dynamic label,
    dynamic whisePictureId,
  }) =>
      HomeDetailPictureUrl(
        id: id ?? this.id,
        url: url ?? this.url,
        compressedUrl: compressedUrl ?? this.compressedUrl,
        label: label ?? this.label,
        whisePictureId: whisePictureId ?? this.whisePictureId,
      );
}

class HomeDetailAgency {
  int? agencyId;
  String? label;
  String? logo;

  HomeDetailAgency({this.agencyId, this.label, this.logo});

  HomeDetailAgency.fromJson(Map<String, dynamic> json) {
    agencyId = json["agencyId"];
    label = json["label"];
    logo = json["logo"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["agencyId"] = agencyId;
    _data["label"] = label;
    _data["logo"] = logo;
    return _data;
  }

  HomeDetailAgency copyWith({
    int? agencyId,
    String? label,
    String? logo,
  }) =>
      HomeDetailAgency(
        agencyId: agencyId ?? this.agencyId,
        label: label ?? this.label,
        logo: logo ?? this.logo,
      );
}

class HomeDetailContact {
  num? id;
  String? displayName;
  String? thumbnail;
  String? firebaseId;
  String? uniqueId;

  HomeDetailContact({
    this.id,
    this.displayName,
    this.thumbnail,
    this.firebaseId,
    this.uniqueId,
  });

  HomeDetailContact.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    displayName = json["displayName"];
    thumbnail = json["thumbnail"];
    firebaseId = json["firebaseId"];
    uniqueId = json["uniqueId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["displayName"] = displayName;
    _data["thumbnail"] = thumbnail;
    _data["firebaseId"] = firebaseId;
    _data["uniqueId"] = uniqueId;
    return _data;
  }

  HomeDetailContact copyWith({
    num? id,
    String? displayName,
    String? thumbnail,
    String? firebaseId,
  }) =>
      HomeDetailContact(
        id: id ?? this.id,
        displayName: displayName ?? this.displayName,
        thumbnail: thumbnail ?? this.thumbnail,
        firebaseId: firebaseId ?? this.firebaseId,
      );
}
