class VideoUrl {
  String? name;
  String? videoUrl;

  VideoUrl({this.name, this.videoUrl});

  VideoUrl.fromJson(Map<String, dynamic> json) {
    if (json["name"] is String) this.name = json["name"];
    if (json["videoUrl"] is String) this.videoUrl = json["videoUrl"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["name"] = this.name;
    data["videoUrl"] = this.videoUrl;
    return data;
  }
}
