class ConfirmEmailCodeResponse {
  bool? status;
  int? limit;
  String? token;
  bool? confirmedCode;
  int? confirmType;

  ConfirmEmailCodeResponse(
      {this.status,
      this.limit,
      this.token,
      this.confirmedCode,
      this.confirmType});

  ConfirmEmailCodeResponse.fromJson(Map<String, dynamic> json) {
    if (json["status"] is bool) this.status = json["status"];
    if (json["limit"] is int) this.limit = json["limit"];
    if (json["token"] is String) this.token = json["token"];
    if (json["confirmedCode"] is bool)
      this.confirmedCode = json["confirmedCode"];
    if (json["confirmType"] is int) this.confirmType = json["confirmType"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["status"] = this.status;
    data["limit"] = this.limit;
    data["token"] = this.token;
    data["confirmedCode"] = this.confirmedCode;
    data["confirmType"] = this.confirmType;
    return data;
  }
}
