class DateChoiseModel {
  late String name;
  late int id;
  bool select = false;

  DateChoiseModel({required this.id, required this.name, this.select = false});

  DateChoiseModel.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    id = json['id'];
  }

  DateChoiseModel.empty() {
    id = 0;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['id'] = this.id;
    return data;
  }
}
