class DigicodeLogModel {
  int? id;
  int? digicodeId;
  String? productSerial;
  String? placeCity;
  String? placeLabel;
  int? placeLng;
  int? placeLat;
  String? placeCountry;
  String? placeZip;
  String? placeStreet1;
  String? placeStreet2;
  String? code;
  int? typedAt;
  int? success;
  int? display;
  int? manualUnlock;
  String? digicodeName;
  String? labelTyper;
  String? publicName;
  String? utcModifier;

  DigicodeLogModel(
      {this.id,
      this.digicodeId,
      this.productSerial,
      this.placeCity,
      this.placeLabel,
      this.placeLng,
      this.placeLat,
      this.placeCountry,
      this.placeZip,
      this.placeStreet1,
      this.placeStreet2,
      this.code,
      this.typedAt,
      this.success,
      this.display,
      this.manualUnlock,
      this.digicodeName,
      this.labelTyper,
      this.publicName,
      this.utcModifier});

  String address() =>
      ((placeStreet1 ?? '').isNotEmpty ? "$placeStreet1, " : "") +
      ((placeCity ?? '').isNotEmpty ? "$placeCity, " : "") +
      (placeCountry ?? '');

  DigicodeLogModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["digicodeId"] is int) this.digicodeId = json["digicodeId"];
    if (json["productSerial"] is String)
      this.productSerial = json["productSerial"];
    if (json["placeCity"] is String) this.placeCity = json["placeCity"];
    if (json["placeLabel"] is String) this.placeLabel = json["placeLabel"];
    if (json["placeLng"] is int) this.placeLng = json["placeLng"];
    if (json["placeLat"] is int) this.placeLat = json["placeLat"];
    if (json["placeCountry"] is String)
      this.placeCountry = json["placeCountry"];
    if (json["placeZip"] is String) this.placeZip = json["placeZip"];
    if (json["placeStreet1"] is String)
      this.placeStreet1 = json["placeStreet1"];
    if (json["placeStreet2"] is String)
      this.placeStreet2 = json["placeStreet2"];
    if (json["code"] is String) this.code = json["code"];
    if (json["typedAt"] is int) this.typedAt = json["typedAt"];
    if (json["success"] is int) this.success = json["success"];
    if (json["display"] is int) this.display = json["display"];
    if (json["manualUnlock"] is int) this.manualUnlock = json["manualUnlock"];
    if (json["digicodeName"] is String)
      this.digicodeName = json["digicodeName"];
    if (json["labelTyper"] is String) this.labelTyper = json["labelTyper"];
    if (json["publicName"] is String) this.publicName = json["publicName"];
    if (json["utcModifier"] is String) this.utcModifier = json["utcModifier"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["digicodeId"] = this.digicodeId;
    data["productSerial"] = this.productSerial;
    data["placeCity"] = this.placeCity;
    data["placeLabel"] = this.placeLabel;
    data["placeLng"] = this.placeLng;
    data["placeLat"] = this.placeLat;
    data["placeCountry"] = this.placeCountry;
    data["placeZip"] = this.placeZip;
    data["placeStreet1"] = this.placeStreet1;
    data["placeStreet2"] = this.placeStreet2;
    data["code"] = this.code;
    data["typedAt"] = this.typedAt;
    data["success"] = this.success;
    data["display"] = this.display;
    data["manualUnlock"] = this.manualUnlock;
    data["digicodeName"] = this.digicodeName;
    data["labelTyper"] = this.labelTyper;
    data["publicName"] = this.publicName;
    data["utcModifier"] = this.utcModifier;
    return data;
  }
}
