class EmergencyResult {
  String? name;
  String? phone;

  EmergencyResult({this.name, this.phone});

  EmergencyResult.fromJson(Map<String, dynamic> json) {
    if (json["name"] is String) this.name = json["name"];
    if (json["phone"] is String) this.phone = json["phone"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["name"] = this.name;
    data["phone"] = this.phone;
    return data;
  }
}
