class ReminderType {
  String? id;
  String? name;
  String? pictureUrl;

  bool isCustomByUser = false;

  ReminderType(
      {this.id, this.name, this.pictureUrl, this.isCustomByUser = false});

  ReminderType.fromJson(Map<String, dynamic> json) {
    if (json["id"] is String) this.id = json["id"];
    if (json["name"] is String) this.name = json["name"];
    if (json["pictureUrl"] is String) this.pictureUrl = json["pictureUrl"];
    isCustomByUser = json['isCustomByUser'] ?? false;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["name"] = this.name;
    data["pictureUrl"] = this.pictureUrl;
    data["isCustomByUser"] = this.isCustomByUser;
    return data;
  }
}
